"sir.test" <-
function(object, nd=length(object$eval)) {
    if(class(object) != "csir" && class(object) != "ds") {
        stop("wrong class of object in sir.test\n"); 
    }
    e = sort(object$eval);
    p = length(object$eval);
    n = length(object$y);
    l = min(p, nd)
    chisq = numeric(l);
    df    = numeric(l);
    p.val = numeric(l);
    for (i in 0:(l-1)){
        j = i+1;
        chisq[j] = n*sum(e[1:(p-i)])
        df[j] = (p-i)*(object$nslice-i-1)
        p.val[j] = 1-pchisq(chisq[j], df[j])
    }
    test = data.frame(Chisq=chisq, df=df, p.value=p.val);
    rnames = character(l);
    for(i in 1:l){
        rnames[i] = paste("D=", i-1, " vs. ", "D>=", i, sep="");
    }
    rownames(test) = rnames;
    test
}

